# __gnu_cxx::enc_filebuf< _CharT > Class Template Reference

Inheritance diagram for __gnu_cxx::enc_filebuf< _CharT >:

List of all members.

## Detailed Description

### template<typename _CharT>
class __gnu_cxx::enc_filebuf< _CharT >

class enc_filebuf.

Definition at line 45 of file enc_filebuf.h.

- locale getloc () const
- locale pubimbue (const locale &__loc)
- pos_type pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
- pos_type pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
- __streambuf_type * pubsetbuf (char_type *__s, streamsize __n)
- int pubsync ()
- locale _M_buf_locale
- char_type * _M_in_beg
- char_type * _M_in_cur
- char_type * _M_in_end
- char_type * _M_out_beg
- char_type * _M_out_cur
- char_type * _M_out_end

## Public Types

- typedef codecvt< char_type,
  char, __state_type > __codecvt_type
- typedef __basic_file< char > __file_type
- typedef basic_filebuf< char_type,
  traits_type > __filebuf_type
- typedef traits_type::state_type __state_type
- typedef basic_streambuf< char_type,
  traits_type > __streambuf_type
- typedef _CharT char_type
- typedef traits_type::int_type int_type
- typedef traits_type::off_type off_type
- typedef traits_type::pos_type pos_type
- typedef traits_type::state_type state_type
- typedef encoding_char_traits<
  _CharT > traits_type

## Public Member Functions

- __filebuf_type * close ()
- enc_filebuf (state_type &__state)
- streamsize in_avail ()
- bool is_open () const throw ()
- __filebuf_type * open (const char *__s, ios_base::openmode __mode)
- int_type sbumpc ()
- int_type sgetc ()
- streamsize sgetn (char_type *__s, streamsize __n)
- int_type snextc ()
- int_type sputbackc (char_type __c)
- int_type sputc (char_type __c)
- streamsize sputn (const char_type *__s, streamsize __n)
- void stossc ()
- int_type sungetc ()

## Protected Member Functions

- void _M_allocate_internal_buffer ()
- bool _M_convert_to_external (char_type *, streamsize)
- void _M_create_pback ()
- void _M_destroy_internal_buffer () throw ()
- void _M_destroy_pback () throw ()
- pos_type _M_seek (off_type __off, ios_base::seekdir __way, __state_type __state)
- void _M_set_buffer (streamsize __off)
- bool _M_terminate_output ()
- void gbump (int __n)
- virtual void imbue (const locale &__loc)
- virtual int_type overflow (int_type __c=_Traits::eof())
- virtual int_type pbackfail (int_type __c=_Traits::eof())
- void pbump (int __n)
- virtual pos_type seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
- virtual pos_type seekpos (pos_type __pos, ios_base::openmode __mode=ios_base::in|ios_base::out)
- virtual __streambuf_type * setbuf (char_type *__s, streamsize __n)
- void setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
- void setp (char_type *__pbeg, char_type *__pend)
- virtual streamsize showmanyc ()
- virtual int sync ()
- virtual int_type uflow ()
- virtual int_type underflow ()
- virtual streamsize xsgetn (char_type *__s, streamsize __n)
- virtual streamsize xsputn (const char_type *__s, streamsize __n)

- char_type * eback () const
- char_type * egptr () const
- char_type * gptr () const

- char_type * epptr () const
- char_type * pbase () const
- char_type * pptr () const

## Protected Attributes

- char_type * _M_buf
- bool _M_buf_allocated
- size_t _M_buf_size
- const __codecvt_type * _M_codecvt
- char * _M_ext_buf
- streamsize _M_ext_buf_size
- char * _M_ext_end
- const char * _M_ext_next
- __file_type _M_file
- __c_lock _M_lock
- ios_base::openmode _M_mode
- bool _M_reading
- __state_type _M_state_beg
- __state_type _M_state_cur
- __state_type _M_state_last
- bool _M_writing

- char_type _M_pback
- char_type * _M_pback_cur_save
- char_type * _M_pback_end_save
- bool _M_pback_init

## Friends

- template<bool _IsMove, typename _CharT2> __gnu_cxx::__enable_if< __is_char<
  _CharT2 >::__value, _CharT2
  * >::__type __copy_move_a2 (istreambuf_iterator< _CharT2 >, istreambuf_iterator< _CharT2 >, _CharT2 *)
- streamsize __copy_streambufs_eof (__streambuf_type *, __streambuf_type *, bool &)
- class basic_ios< char_type, traits_type >
- class basic_istream< char_type, traits_type >
- class basic_ostream< char_type, traits_type >
- template<typename _CharT2> __gnu_cxx::__enable_if< __is_char<
  _CharT2 >::__value, istreambuf_iterator<
  _CharT2 > >::__type find (istreambuf_iterator< _CharT2 >, istreambuf_iterator< _CharT2 >, const _CharT2 &)
- template<typename _CharT2, typename _Traits2, typename _Alloc> basic_istream< _CharT2, _Traits2 > & getline (basic_istream< _CharT2, _Traits2 > &, basic_string< _CharT2, _Traits2, _Alloc > &, _CharT2)
- class ios_base
- class istreambuf_iterator< char_type, traits_type >
- template<typename _CharT2, typename _Traits2, typename _Alloc> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, basic_string< _CharT2, _Traits2, _Alloc > &)
- template<typename _CharT2, typename _Traits2> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, _CharT2 *)
- class ostreambuf_iterator< char_type, traits_type >

## Member Typedef Documentation

template<typename _CharT, typename _Traits>

typedef basic_streambuf<char_type, traits_type> std::basic_filebuf< _CharT, _Traits >::__streambuf_type `[inherited]`

This is a non-standard type.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 78 of file fstream.

template<typename _CharT, typename _Traits>

typedef _CharT std::basic_filebuf< _CharT, _Traits >::char_type `[inherited]`

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >.

Definition at line 72 of file fstream.

template<typename _CharT, typename _Traits>

typedef traits_type::int_type std::basic_filebuf< _CharT, _Traits >::int_type `[inherited]`

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >.

Definition at line 74 of file fstream.

template<typename _CharT, typename _Traits>

typedef traits_type::off_type std::basic_filebuf< _CharT, _Traits >::off_type `[inherited]`

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Reimplemented in __gnu_cxx::stdio_filebuf< _CharT, _Traits >.

Definition at line 76 of file fstream.

template<typename _CharT>

typedef traits_type::pos_type __gnu_cxx::enc_filebuf< _CharT >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_filebuf< _CharT, _Traits >.

Definition at line 51 of file enc_filebuf.h.

template<typename _CharT>

typedef encoding_char_traits<_CharT> __gnu_cxx::enc_filebuf< _CharT >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_filebuf< _CharT, _Traits >.

Definition at line 49 of file enc_filebuf.h.

## Member Function Documentation

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_create_pback | ( |  | ) | `[inline, protected, inherited]`

Initializes pback buffers, and moves normal buffers to safety. Assumptions: _M_in_cur has already been moved back

Definition at line 173 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail().

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_destroy_pback | ( |  | ) | throw ()`[inline, protected, inherited]`

Deactivates pback buffer contents, and restores normal buffer. Assumptions: The pback buffer has only moved forward.

Definition at line 190 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_filebuf< _CharT, _Traits >::seekpos(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_set_buffer | ( | streamsize | __off | ) | `[inline, protected, inherited]`

This function sets the pointers of the internal buffer, both get and put areas. Typically:

__off == egptr() - eback() upon underflow/uflow ('read' mode); __off == 0 upon overflow ('write' mode); __off == -1 upon open, setbuf, seekoff/pos ('uncommitted' mode).

NB: epptr() - pbase() == _M_buf_size - 1, since _M_buf_size reflects the actual allocated memory and the last cell is reserved for the overflow char of a full put area.

Definition at line 375 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::_M_seek(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::open(), std::basic_filebuf< _CharT, _Traits >::overflow(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::close | ( |  | ) | `[inherited]`

Closes the currently associated file.

Returns:
  `this` on success, NULL on failure

If no file is currently open, this function immediately fails.

If a "put buffer area" exists, `overflow(eof)` is called to flush all the characters. The file is then closed.

If any operations fail, this function also fails.

Definition at line 133 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::_M_file, std::basic_filebuf< _CharT, _Traits >::_M_terminate_output(), and std::__basic_file< char >::close().

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::eback | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 463 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::egptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 469 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::gbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the read position.

Parameters:

  | n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 479 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 226 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::gptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 466 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) | `[protected, virtual, inherited]`

Changes translations.

Parameters:

  | loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, "Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained."

Note:
  Base class version does nothing.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 858 of file fstream.tcc.

References std::__check_facet(), std::basic_filebuf< _CharT, _Traits >::_M_codecvt, std::basic_filebuf< _CharT, _Traits >::_M_ext_buf, std::basic_filebuf< _CharT, _Traits >::_M_ext_end, std::basic_filebuf< _CharT, _Traits >::_M_ext_next, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_state_beg, std::basic_filebuf< _CharT, _Traits >::_M_state_cur, std::basic_filebuf< _CharT, _Traits >::_M_state_last, std::basic_filebuf< _CharT, _Traits >::_M_terminate_output(), std::basic_filebuf< _CharT, _Traits >::_M_writing, std::ios_base::cur, std::basic_streambuf< _CharT, _Traits >::eback(), and std::basic_filebuf< _CharT, _Traits >::seekoff().

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::in_avail | ( |  | ) | `[inline, inherited]`

Looking ahead into the stream.

Returns:
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 266 of file streambuf.

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::is_open | ( |  | ) | const throw ()`[inline, inherited]`

Returns true if the external file is open.

Definition at line 223 of file fstream.

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::open | ( | const char * | __s,
|  | ios_base::openmode | __mode |
| ) |  |  | `[inherited]`

Opens an external file.

Parameters:

  | s | The name of the file.
  | mode | The open mode flags.

Returns:
  `this` on success, NULL on failure

If a file is already open, this function immediately fails. Otherwise it tries to open the file named s using the flags given in mode.

Table 92, adapted here, gives the relation between openmode combinations and the equivalent fopen() flags. (NB: lines app, in|out|app, in|app, binary|app, binary|in|out|app, and binary|in|app per DR 596) +---------------------------------------------------------+ | ios_base Flag combination stdio equivalent | |binary in out trunc app | +---------------------------------------------------------+ | + "w" | | + + "a" | | + "a" | | + + "w" | | + "r" | | + + "r+" | | + + + "w+" | | + + + "a+" | | + + "a+" | +---------------------------------------------------------+ | + + "wb" | | + + + "ab" | | + + "ab" | | + + + "wb" | | + + "rb" | | + + + "r+b" | | + + + + "w+b" | | + + + + "a+b" | | + + + "a+b" | +---------------------------------------------------------+

Definition at line 99 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::_M_allocate_internal_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_file, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_state_beg, std::basic_filebuf< _CharT, _Traits >::_M_state_cur, std::basic_filebuf< _CharT, _Traits >::_M_state_last, std::basic_filebuf< _CharT, _Traits >::_M_writing, std::ios_base::ate, std::ios_base::end, and std::__basic_file< char >::open().

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::overflow | ( | int_type | __c = `_Traits::eof()` | ) | `[protected, virtual, inherited]`

Consumes data from the buffer; writes to the controlled sequence.

Parameters:

  | c | An additional character to consume.

Returns:
  eof() to indicate failure, something else (usually c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is "consumed", with "some effect" on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if c is not `eof()`.

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 413 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_convert_to_external(), std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_writing, std::ios_base::out, std::basic_streambuf< _CharT, _Traits >::pbase(), std::basic_streambuf< _CharT, _Traits >::pbump(), and std::basic_streambuf< _CharT, _Traits >::pptr().

Referenced by std::basic_filebuf< _CharT, _Traits >::_M_terminate_output().

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::pbackfail | ( | int_type | __c = `_Traits::eof()` | ) | `[protected, virtual, inherited]`

Tries to back up the input sequence.

Parameters:

  | c | The character to be inserted back into the sequence.

Returns:
  eof() on failure, "some other value" on success

Postcondition:
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 361 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::_M_create_pback(), std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_pback_init, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_writing, std::ios_base::cur, std::basic_streambuf< _CharT, _Traits >::gptr(), and std::ios_base::in.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::pbase | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 510 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::pbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the write position.

Parameters:

  | n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 526 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_streambuf< _CharT, _Traits >::xsputn().

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::pubimbue | ( | const locale & | __loc | ) | `[inline, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 209 of file streambuf.

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 243 of file streambuf.

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 248 of file streambuf.

template<typename _CharT, typename _Traits>

__streambuf_type* std::basic_streambuf< _CharT, _Traits >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry points for derived buffer functions.

The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 239 of file streambuf.

template<typename _CharT, typename _Traits>

int std::basic_streambuf< _CharT, _Traits >::pubsync | ( |  | ) | `[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 253 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::sync().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sbumpc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 298 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), and std::istreambuf_iterator< _CharT, _Traits >::operator++().

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 689 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::_M_codecvt, std::basic_filebuf< _CharT, _Traits >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::_M_ext_buf, std::basic_filebuf< _CharT, _Traits >::_M_ext_end, std::basic_filebuf< _CharT, _Traits >::_M_ext_next, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_seek(), std::basic_filebuf< _CharT, _Traits >::_M_state_beg, std::basic_filebuf< _CharT, _Traits >::_M_state_last, std::__codecvt_abstract_base< _InternT, _ExternT, _StateT >::always_noconv(), std::ios_base::cur, std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::__codecvt_abstract_base< _InternT, _ExternT, _StateT >::encoding(), and std::__codecvt_abstract_base< _InternT, _ExternT, _StateT >::length().

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue().

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekpos | ( | pos_type | __pos,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 742 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::_M_seek(), and std::ios_base::beg.

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::__streambuf_type * std::basic_filebuf< _CharT, _Traits >::setbuf | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[protected, virtual, inherited]`

Manipulates the buffer.

Parameters:

  | s | Pointer to a buffer area.
  | n | Size of s.

Returns:
  `this`

If no file has been opened, and both s and n are zero, then the stream becomes unbuffered. Otherwise, `s` is used as a buffer; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for more.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 662 of file fstream.tcc.

References std::basic_filebuf< _CharT, _Traits >::_M_buf, and std::basic_filebuf< _CharT, _Traits >::_M_buf_size.

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend |
| ) |  |  | `[inline, protected, inherited]`

Setting the three read area pointers.

Parameters:

  | gbeg | A pointer.
  | gnext | A pointer.
  | gend | A pointer.

Postcondition:
  gbeg == `eback()`, gnext == `gptr()`, and gend == `egptr()`

Definition at line 490 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync().

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend |
| ) |  |  | `[inline, protected, inherited]`

Setting the three write area pointers.

Parameters:

  | pbeg | A pointer.
  | pend | A pointer.

Postcondition:
  pbeg == `pbase()`, pbeg == `pptr()`, and pend == `epptr()`

Definition at line 536 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sgetc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 320 of file streambuf.

Referenced by std::__copy_streambufs_eof(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), and std::basic_istream< _CharT, _Traits >::sentry::sentry().

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sgetn | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry point for xsgetn.

Parameters:

  | s | A buffer area.
  | n | A count.

Returns xsgetn(s,n). The effect is to fill s[0] through s[n-1] with characters from the input sequence, if possible.

Definition at line 339 of file streambuf.

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::showmanyc | ( |  | ) | `[protected, virtual, inherited]`

Investigating the data available.

Returns:
  An estimate of the number of characters available in the input sequence, or -1.

"If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail." [27.5.2.4.3]/1

Note:
  Base class version does nothing, returns zero.

  The standard adds that "the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return "immediately".

  The standard adds that "the morphemes of `showmanyc` are "es-how-many-see", not "show-manic".

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 183 of file fstream.tcc.

References std::__check_facet(), std::basic_filebuf< _CharT, _Traits >::_M_codecvt, std::basic_filebuf< _CharT, _Traits >::_M_file, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::ios_base::binary, std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, and std::__basic_file< char >::showmanyc().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::snextc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 280 of file streambuf.

Referenced by std::__copy_streambufs_eof(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), and std::basic_istream< _CharT, _Traits >::sentry::sentry().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputbackc | ( | char_type | __c | ) | `[inline, inherited]`

Pushing characters back into the input stream.

Parameters:

  | c | The character to push back.

Returns:
  The previous character, if possible.

Similar to sungetc(), but c is pushed onto the stream instead of "the previous character". If successful, the next character fetched from the input stream will be c.

Definition at line 353 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::putback().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputc | ( | char_type | __c | ) | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | c | A character to output.

Returns:
  c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores c in that position, increments the position, and returns `traits::to_int_type(c)`. If a write position is not available, returns `overflow(c)`.

Definition at line 405 of file streambuf.

Referenced by std::__copy_streambufs_eof(), std::basic_istream< _CharT, _Traits >::get(), and std::ostreambuf_iterator< _CharT, _Traits >::operator=().

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sputn | ( | const char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | s | A buffer read area.
  | n | A count.

One of two public output functions.

Returns xsputn(s,n). The effect is to write s[0] through s[n-1] to the output sequence, if possible.

Definition at line 431 of file streambuf.

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::stossc | ( |  | ) | `[inline, inherited]`

Tosses a character.

Advances the read pointer, ignoring the character that would have been read.

See http://gcc.gnu.org/ml/libstdc++/2002-05/msg00168.html

Definition at line 763 of file streambuf.

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sungetc | ( |  | ) | `[inline, inherited]`

Moving backwards in the input stream.

Returns:
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to "unget" the last character "gotten".

Definition at line 378 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::unget().

template<typename _CharT, typename _Traits>

int std::basic_filebuf< _CharT, _Traits >::sync | ( |  | ) | `[protected, virtual, inherited]`

Synchronizes the buffer arrays with the controlled sequences.

Returns:
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of "failure".

Note:
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 841 of file fstream.tcc.

References std::basic_streambuf< _CharT, _Traits >::pptr().

template<typename _CharT, typename _Traits>

virtual int_type std::basic_streambuf< _CharT, _Traits >::uflow | ( |  | ) | `[inline, protected, virtual, inherited]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented in __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >.

Definition at line 681 of file streambuf.

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::underflow | ( |  | ) | `[protected, virtual, inherited]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is "refilled". In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#6

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 209 of file fstream.tcc.

References std::__check_facet(), __N, std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_codecvt, std::basic_filebuf< _CharT, _Traits >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::_M_ext_buf, std::basic_filebuf< _CharT, _Traits >::_M_ext_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_ext_end, std::basic_filebuf< _CharT, _Traits >::_M_ext_next, std::basic_filebuf< _CharT, _Traits >::_M_file, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_state_cur, std::basic_filebuf< _CharT, _Traits >::_M_state_last, std::basic_filebuf< _CharT, _Traits >::_M_writing, std::copy(), std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::__codecvt_abstract_base< _InternT, _ExternT, _StateT >::encoding(), std::__codecvt_abstract_base< _InternT, _ExternT, _StateT >::in(), std::ios_base::in, std::__codecvt_abstract_base< _InternT, _ExternT, _StateT >::max_length(), std::min(), and std::__basic_file< char >::xsgetn().

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::xsgetn | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[protected, virtual, inherited]`

Multiple character extraction.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to assign.

Returns:
  The number of characters assigned.

Fills s[0] through s[n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 532 of file fstream.tcc.

References std::__check_facet(), __N, std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_codecvt, std::basic_filebuf< _CharT, _Traits >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::_M_file, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_pback_init, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_writing, std::copy(), std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, std::basic_streambuf< _CharT, _Traits >::xsgetn(), and std::__basic_file< char >::xsgetn().

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::xsputn | ( | const char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[protected, virtual, inherited]`

Multiple character insertion.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to write.

Returns:
  The number of characters written.

Writes s[0] through s[n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 615 of file fstream.tcc.

References std::__check_facet(), std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_codecvt, std::basic_filebuf< _CharT, _Traits >::_M_file, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_writing, std::basic_streambuf< _CharT, _Traits >::epptr(), std::min(), std::ios_base::out, std::basic_streambuf< _CharT, _Traits >::pbase(), std::basic_streambuf< _CharT, _Traits >::pptr(), std::basic_streambuf< _CharT, _Traits >::xsputn(), and std::__basic_file< char >::xsputn_2().

## Member Data Documentation

template<typename _CharT, typename _Traits>

char_type* std::basic_filebuf< _CharT, _Traits >::_M_buf `[protected, inherited]`

Pointer to the beginning of internal buffer.

Definition at line 110 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::_M_destroy_internal_buffer(), and std::basic_filebuf< _CharT, _Traits >::setbuf().

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::_M_buf_locale `[protected, inherited]`

Current locale setting.

Definition at line 192 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::basic_filebuf().

template<typename _CharT, typename _Traits>

size_t std::basic_filebuf< _CharT, _Traits >::_M_buf_size `[protected, inherited]`

Actual size of internal buffer. This number is equal to the size of the put area + 1 position, reserved for the overflow char of a full area.

Definition at line 117 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_filebuf< _CharT, _Traits >::setbuf(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

template<typename _CharT, typename _Traits>

char* std::basic_filebuf< _CharT, _Traits >::_M_ext_buf `[protected, inherited]`

Buffer for external characters. Used for input when codecvt::always_noconv() == false. When valid, this corresponds to eback().

Definition at line 152 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::_M_destroy_internal_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_seek(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::seekoff(), and std::basic_filebuf< _CharT, _Traits >::underflow().

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::_M_ext_buf_size `[protected, inherited]`

Size of buffer held by _M_ext_buf.

Definition at line 157 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::_M_destroy_internal_buffer(), and std::basic_filebuf< _CharT, _Traits >::underflow().

template<typename _CharT, typename _Traits>

const char* std::basic_filebuf< _CharT, _Traits >::_M_ext_next `[protected, inherited]`

Pointers into the buffer held by _M_ext_buf that delimit a subsequence of bytes that have been read but not yet converted. When valid, _M_ext_next corresponds to egptr().

Definition at line 164 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::_M_destroy_internal_buffer(), std::basic_filebuf< _CharT, _Traits >::_M_seek(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::seekoff(), and std::basic_filebuf< _CharT, _Traits >::underflow().

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_beg `[protected, inherited]`

This is based on _IO_FILE, just reordered to be more consistent, and is intended to be the most minimal abstraction for an internal buffer.

- get == input == read
- put == output == write

Definition at line 184 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_cur `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 185 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_end `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 186 of file streambuf.

template<typename _CharT, typename _Traits>

ios_base::openmode std::basic_filebuf< _CharT, _Traits >::_M_mode `[protected, inherited]`

Place to stash in || out || in | out settings for current filebuf.

Definition at line 95 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::open(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_beg `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 187 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_cur `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 188 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_end `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 189 of file streambuf.

template<typename _CharT, typename _Traits>

char_type std::basic_filebuf< _CharT, _Traits >::_M_pback `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 138 of file fstream.

template<typename _CharT, typename _Traits>

char_type* std::basic_filebuf< _CharT, _Traits >::_M_pback_cur_save `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 139 of file fstream.

template<typename _CharT, typename _Traits>

char_type* std::basic_filebuf< _CharT, _Traits >::_M_pback_end_save `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 140 of file fstream.

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_pback_init `[protected, inherited]`

Necessary bits for putback buffer management.

Note:
  pbacks of over one character are not currently supported.

Definition at line 141 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_reading `[protected, inherited]`

_M_reading == false && _M_writing == false for 'uncommitted' mode; _M_reading == true for 'read' mode; _M_writing == true for 'write' mode;

NB: _M_reading == true && _M_writing == true is unused.

Definition at line 129 of file fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::_M_seek(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::open(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_filebuf< _CharT, _Traits >::seekoff(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

The documentation for this class was generated from the following file:

- enc_filebuf.h